package {
	import org.flixel.FlxButton;
	import org.flixel.FlxG;
	import org.flixel.FlxGroup;
	import org.flixel.FlxSprite;
	import org.flixel.FlxText;

	/**
	 * @author Yori Kvitchko
	 */
	public class BlueprintButtons extends FlxGroup {
		private var _buttons:Array;
//		private var _buttonLetters:Array;

		public function BlueprintButtons() {
			super();
			
			var b:FlxButton;
			var s:FlxSprite;
			var t1:FlxText;
			var t2:FlxText;
			
			_buttons = new Array();
//			_buttonLetters = ["", "I", "E", "W", "N", "S"];
			
			if(PlayState.tutorials) {
				for (var i:int = 1;i < PlayState.tutorials.length;i++) {
					s = new FlxSprite(80 + 60 * i, 0);
					s.createGraphic(30, 30, 0xffbbbbbb);
					s.scrollFactor.x = s.scrollFactor.y = 0;
					add(s);
					b = new FlxButton(80 + 60 * i, 0, onTut);
					b.loadGraphic((new FlxSprite()).createGraphic(30, 30, 0xff392b8c), (new FlxSprite()).createGraphic(30, 30, 0xffffffff));
					b.scrollFactor.x = b.scrollFactor.y = 0;
					t1 = new FlxText(0, 5, 30, "#" + i.toPrecision(1));
					t1.color = 0xffffff;
					t1.size = 16;
					t1.alignment = "center";
					t2 = new FlxText(0, 5, 30, "#" + i.toPrecision(1));
					t2.color = 0x392b8c;
					t2.size = 16;
					t2.alignment = "center";
					b.loadText(t1, t2);
					b.visible = false;
					_buttons[i] = add(b);
				}
			}
			
			t1 = new FlxText(0, 5, 125, "Blueprints: ");
			t1.scrollFactor.x = t1.scrollFactor.y = 0;
			t1.color = 0xffffff;
			t1.size = 16;
			t1.alignment = "center";
			add(t1);
		}

		override public function update():void {
			if(PlayState.viewedTutorials) {
				for (var i:int = 1;i < PlayState.viewedTutorials.length;i++) {
					FlxButton(_buttons[i]).visible = PlayState.viewedTutorials[i];
				}
			}
			super.update();
		}

		private function onTut():void {
			for (var i:int = 1;i < _buttons.length;i++) {
				if(FlxButton(_buttons[i]).overlaps(FlxG.mouse.cursor)) {
					PlayState.loadTutorial(i, true);
				}
			}
		}
	}
}
