package {

	/*
	 * Represents a sequence of actions to be performed in sequence
	 */

	public class Cinematic {

		public var title : String;
		public var level : int;
		public var used : Boolean = false;
		public var optional : Boolean = false;
		public var actions : Array; // all the action that comprise this scene
		public var focus : uint; // character around which the action is focused

		public function Cinematic(level : int, title : String, a : Action = null) {
			this.title = title;
			this.level = level;
			
			actions = new Array();
			if (a) actions.push(a);
		}

		public function pushAction(action : Action) : void {
			actions.push(action);
		}

		public function updateChar(name : String) : Cinematic {
			var count : uint = 0;
			
			for each (var action : Action in actions) {
				if (action.character == "*") {
					action.character = name;
					count++;
				}
			}
			return this;
		}

		public function toString() : String {
			return "[" + level + ": " + title + "]";
		}
	}
}
