package {
	import org.flixel.FlxG;
	import org.flixel.FlxSprite;

	/**
	 * @author Yori Kvitchko
	 */
	public class Explosion extends FlxSprite {
		private static const FADE_TIME:Number = 0.5;
		private static const SPLAT_TIME:Number = 0.2;
		
		private var _fadeTimer:Number;
		private var _fading:Boolean;
		
		[Embed(source="../data/expl_1.png")] 
		private var ImgExpl1:Class;
		
		[Embed(source="../data/expl_2.png")] 
		private var ImgExpl2:Class;
		
		[Embed(source="../data/expl_3.png")] 
		private var ImgExpl3:Class;
		
		[Embed(source="../data/sounds/crash.mp3")] 
		private var SndCrash:Class;
		
		public function Explosion(size:int = 0) {
			super(-500, -500);
			solid = false;
			moves = false;
			visible = false;
			
			if(size == 0) {
				var i:int = Math.floor(Math.random() * 6);
				
				if(i < 3) {
					loadGraphic(ImgExpl1);
				} else if (i < 4) {
					loadGraphic(ImgExpl2);
				} else {
					loadGraphic(ImgExpl3);
				}
			} else {
				if(size == 1) {
					loadGraphic(ImgExpl1);
				} else if (size == 2) {
					loadGraphic(ImgExpl2);
				} else if (size == 3)  {
					loadGraphic(ImgExpl3);
				}
			}
			
			_fadeTimer = FADE_TIME;
			_fading = false;
		}
		
		override public function update():void {
			_fadeTimer -= FlxG.elapsed;
			
			if(_fading && _fadeTimer <= 0) {
				visible = false;
				alpha = 1.0;
			} else {
				alpha = _fadeTimer / FADE_TIME;
			}
			super.update();
		}

		public function explode(X:Number, Y:Number):void {
			reset(X - origin.x, Y - origin.y);
			_fadeTimer = FADE_TIME + SPLAT_TIME;
			_fading = true;
			visible = true;
			FlxG.play(SndCrash, 0.15);
		}
	}
}
