package {
	import cinematics.IntroState;
	import cinematics.StartCinState;

	import org.flixel.FlxG;
	import org.flixel.FlxPoint;
	import org.flixel.FlxSprite;
	import org.flixel.FlxText;

	import flash.net.URLRequest;
	import flash.net.navigateToURL;

	public class MenuState extends FadeState {

		[Embed(source="../data/menu_selector.png")] 
		private var ImgCircle:Class;

		[Embed(source="../data/menu_bg.png")] 
		private var ImgMenu:Class;

		[Embed(source="../data/menu_playbutton.png")] 
		private var ImgPlayButton:Class;

		[Embed(source="../data/menu_levelsbutton.png")] 
		private var ImgLevelsButton:Class;

		[Embed(source="../data/menu_exitbutton.png")] 
		private var ImgExitButton:Class;

		[Embed(source="../data/cursor.png")] 
		private var ImgCursor:Class;

		private var _circleButton1:FlxSprite;
		private var _circleButton2:FlxSprite;
		private var _circleButton3:FlxSprite;
		private var _circleButton4:FlxSprite;
		//		private var _circleButton5:FlxSprite;

		private var _selector:FlxSprite;

		private var _menuBG:FlxSprite;
		private var _title:FlxText;
		private var _title2:FlxText;
		private var _play:FlxText;
		private var _levels:FlxText;
		private var _exit:FlxText;

		override public function create():void {
			
			
			
			// adding circle buttons (FlxSprite) onto the screen
			_menuBG = new FlxSprite(0, 0);
			_menuBG.loadGraphic(ImgMenu, false);
			add(_menuBG);
			
			_title = new FlxText(0, 0, FlxG.width, "Escape from Planet");
			_title.scrollFactor.x = 100;
			_title.scrollFactor.y = 100;
			_title.alignment = "center";
			_title.size = 50;
			_title.color = 0xffff00;
			add(_title);
			
			_title = new FlxText(0, 60, FlxG.width, "DOOM");
			_title.scrollFactor.x = 100;
			_title.scrollFactor.y = 100;
			_title.alignment = "center";
			_title.size = 96;
			_title.color = 0xff0000;
			add(_title);
	
			
			// Play button
			_circleButton1 = new FlxSprite(40, 150);
			_circleButton1.loadGraphic(ImgPlayButton, false);
			add(_circleButton1);
			
					
			_play = new FlxText(110, 370, FlxG.width, "Play");
			_play.scrollFactor.x = 100;
			_play.scrollFactor.y = 100;
			_play.size = 32;
			_play.color = 0xffff00;
			add(_play);
			
			_levels = new FlxText(440, 320, FlxG.width, "Last Time...");
			_levels.scrollFactor.x = 100;
			_levels.scrollFactor.y = 100;
			_levels.size = 18;
			_levels.color = 0xffff00;
			add(_levels);
			
			
			
			// Levels button
			_circleButton2 = new FlxSprite(440, 180);
			_circleButton2.createGraphic(192, 250);
			//add(_circleButton2);
			
			// Settings button
			_circleButton3 = new FlxSprite(380, 150);
			_circleButton3.loadGraphic(ImgLevelsButton, false);
			_circleButton3.scale = new FlxPoint(0.5, 0.5);
			add(_circleButton3);
			
			// Exit button
			_circleButton4 = new FlxSprite(0, 400);
			_circleButton4.loadGraphic(ImgExitButton, false);
			add(_circleButton4);
			
			// Selector
			_selector = new FlxSprite(10, 150);
			_selector.loadGraphic(ImgCircle, true);
			_selector.addAnimation("off", [0], 0); 
			_selector.addAnimation("on", [1], 0);
			_selector.visible = false;
			add(_selector);
			
			_exit = new FlxText(270, 500, FlxG.width, "Credits");
			_exit.scrollFactor.x = 100;
			_exit.scrollFactor.y = 100;
			_exit.size = 28;
			_exit.color = 0xffff00;
			add(_exit);
			
			// Initialize Fade
			super.create();
			
			if(FlxG.music) {
				FlxG.music.stop();
			}
			
			FlxG.mouse.show(ImgCursor, 10, 10);
		}

		override public function update():void {
			super.update();
			
			if(_circleButton1.overlaps(FlxG.mouse.cursor)) {
				
				resetCircles();	
				_selector.visible = true;
				onCircle1();	
			}
			else if(_circleButton2.overlaps(FlxG.mouse.cursor)) {
				
				resetCircles();	
				_selector.visible = true;
				onCircle2();	
			}
			else if(_circleButton3.overlaps(FlxG.mouse.cursor)) {
//				_selector.visible=true;
//				resetCircles();	
//				_selector.visible=true;
//				onCircle3();	
			} 
			else if(_circleButton4.overlaps(FlxG.mouse.cursor)) {
				//				_selector.visible=true;
				resetCircles();	
				_selector.visible = true;
				onCircle4();		
			} else {
				resetCircles();	
				_selector.visible = false;
			}
		}

		private function Intro():void {
			FlxG.level = 0;
			FlxG.state = new IntroState();
		}

		private function onCircle1():void {
			_selector.play("on");
			_selector.x = 20;
			_selector.y = 130;
			_selector.angle = 270;
			if(FlxG.mouse.justPressed()) {
				fadeOut(0.5, false, Intro);
			}
		}

		private function onCircle2():void {
			_selector.play("on");
			_selector.angle = 245;
			_selector.x = 350;
			_selector.y = 180;
			if(FlxG.mouse.justPressed()) {
				fadeOut(0.5, false, Test);
			}
		}

		private function Test():void {
			FlxG.level = -1;
			FlxG.state = new StartCinState();
		}

		private function onCircle3():void {
			_selector.play("on");
			_selector.x = 90;
			_selector.y = 340;
		}

		
		private function onCircle4():void {
			_selector.play("on");
			_selector.x = 220;
			_selector.y = 390;
			_selector.angle = 290;
			if(FlxG.mouse.justPressed()) {
				navigateToURL(new URLRequest("https://sakai.rutgers.edu/access/wiki/site/0a4e9ee5-ee55-4b15-b778-52a05786e504/escape%20from%20planet%20doom.html"));
			}
		}

		private function resetCircles():void {
			_selector.visible = false;
			_selector.play("off");
		}
	}
}

