package base {
	import org.flixel.FlxG;
	import org.flixel.FlxSprite;

	/**
	 * @author Yori Kvitchko
	 */
	public class Impact extends FlxSprite {
		/*
		 * Total life of the Impact Graphic
		 */
		private var life:Number;
		/*
		 * Timer of remaining life
		 */
		private var lifeTimer:Number;

		/*
		 * Splat
		 */
		[Embed(source='../../data/thud.png')]
		private const ImgThud:Class;

		public function Impact(Life:Number) {
			super(-100, -100);
			moves = false;
			solid = false;
			lifeTimer = 0;
			life = Life;
			initGraphics();
			visible = false;
		}

		public function initGraphics():void {
			// No default graphics
		}

		override public function update():void {
			if(lifeTimer > 0) {
				lifeTimer -= FlxG.elapsed;
				alpha = lifeTimer / life;
			} else {
				visible = false;
			}
			
			super.update();
		}

		override public function reset(X:Number, Y:Number):void {
			super.reset(X, Y);
			visible = true;
			lifeTimer = life;
		}
	}
}
