package bosses {
	import org.flixel.FlxObject;
	import org.flixel.FlxSprite;

	import flash.geom.Rectangle;

	/**
	 * @author Yori Kvitchko
	 */
	public class BossHealth extends BossComp {
		private var healthBar:FlxSprite;
		private var healthRect:Rectangle;

		/*
		 * Logo Health Image
		 */
		[Embed(source="../../data/boss_health_logo.png")] 
		private var ImgLogo:Class;

		/*
		 * A component of a larger boss, can be either independant or dependant on a parent
		 */
		public function BossHealth(X:Number, Y:Number, Parent:FlxObject) {
			super(null, X, Y, Parent);
			moves = false;
			solid = false;
			
			healthBar = new FlxSprite();
			healthBar.createGraphic(132, 16, 0xff00ff00, true);
			healthBar.x = x + 4;
			healthBar.y = y + 4;
			
			scrollFactor.x = healthBar.scrollFactor.x = 0;
			scrollFactor.y = healthBar.scrollFactor.y = 0;
			
			healthRect = new Rectangle(0, 0, 0, 20);
		}

		override public function initGraphics():void {
			loadGraphic(ImgLogo);
		}

		override public function update():void {
			healthBar.x = x + 4;
			healthBar.y = y + 4;
			healthRect.width = Math.ceil((1 - Boss(_parent).percentHealth) * 132);
			healthRect.x = 132 - healthRect.width;
			super.update();
		}

		override public function render():void {
			healthBar.pixels.fillRect(healthRect, 0xffff0000);
			healthBar.frame = 0;
			healthBar.render();
			super.render();
		}
	}
}
