package bosses.beztest {
	import bosses.Boss;

	import player.PlayerShip;

	import org.flixel.FlxG;
	import org.flixel.FlxGroup;

	import flash.geom.Point;

	/**
	 * @author Yori Kvitchko
	 */
	public class BezTest extends Boss {
		private var _time:Number;
		private var _blocker:BezTestComp;
		private var _ship:PlayerShip;

		private var _tmp:Point;
		
		[Embed(source='../../../data/beztest_comp_1.png')]
		private const ImgBZComp1:Class;
		[Embed(source='../../../data/beztest_comp_2.png')]
		private const ImgBZComp2:Class;
		[Embed(source='../../../data/beztest_comp_3.png')]
		private const ImgBZComp3:Class;
		[Embed(source='../../../data/beztest_comp_4.png')]
		private const ImgBZComp4:Class;
		[Embed(source='../../../data/beztest_comp_5.png')]
		private const ImgBZComp5:Class;
		[Embed(source='../../../data/beztest_core.png')]
		private const ImgBZCore:Class;

		public function BezTest(Projectiles:FlxGroup) {
			super(Projectiles, 200, 125, 400, 400, 200);
			
			_time = 0;
			
			// Each component is 150 x 150
			var bz_comp:BezTestComp;

			bz_comp = new BezTestComp(Projectiles, 0, 0, this);
			bz_comp.loadGraphic(ImgBZComp1);
			add(bz_comp);
			bz_comp = new BezTestComp(Projectiles, 250, 0, this);
			bz_comp.loadGraphic(ImgBZComp2);
			add(bz_comp);
			bz_comp = new BezTestComp(Projectiles, 0, 250, this);
			bz_comp.loadGraphic(ImgBZComp3);
			add(bz_comp);
			bz_comp = new BezTestComp(Projectiles, 250, 250, this);
			bz_comp.loadGraphic(ImgBZComp4);
			add(bz_comp);
			
			_blocker = BezTestComp(add(new BezTestComp(Projectiles, 125, 275, this)));
			_blocker.loadGraphic(ImgBZComp5);
			
			_tmp = new Point();
			
			// Heart
			var bz_core_comp:BezTestCoreComp = new BezTestCoreComp(Projectiles, 175, 175, this);
			bz_core_comp.loadGraphic(ImgBZCore);
			add(bz_core_comp);
		}

		override public function update():void {
			_time += FlxG.elapsed;

			reset(200 + Math.sin(_time) * 200, 125 + Math.sin(_time * 2) * 50);

			if(SpaceView(FlxG.levels[FlxG.level])) {
				_ship = SpaceView.ship;

				_tmp.x = (x + origin.x) - (_ship.x + _ship.origin.x);
				_tmp.y = (y + origin.y) - (_ship.y + _ship.origin.y);
				_tmp.normalize(-150);

				_blocker.x = x + origin.x + _tmp.x - _blocker.origin.x;
				_blocker.y = y + origin.y + _tmp.y - _blocker.origin.y;
			}

			super.update();
		}
	}
}
