package bosses.bigsquid {
	import base.ProjSpawner;

	import bosses.BossComp;

	import org.flixel.FlxGroup;
	import org.flixel.FlxObject;
	import org.flixel.FlxPoint;

	/**
	 * @author Yori Kvitchko
	 */
	public class BigSquidBossComp extends BossComp {
		// CONSTANTS
		
		/*
		 * Fire interval for bullets
		 */
		private static const BULLET_INTERVAL:Number = 0.15;
		/*
		 * Interval for "waves" of bullets
		 */
		private static const BULLET_WAVE_INTERVAL:Number = 2;

		// VARIABLES
		/*
		 * Timer for Bullet Waves
		 */
		private var _waveTimer:Number;
		/*
		 * Spawner for front bullets
		 */
		private var _bulletSpawner:ProjSpawner;
		/*
		 * Spawner for side bullets
		 */
		private var _sideBulletSpawner:ProjSpawner;
		/*
		 * Pre-movement location, used to compute "velocity"
		 */
		private var _last:FlxPoint;

		// EMBEDDED RESOURCES

		/*
		 * Animated squid graphic
		 */
		[Embed(source='../../../data/boss_big_squid.png')]
		private const ImgBigSquid:Class;

		public function BigSquidBossComp(Projectiles:FlxGroup, X:Number, Y:Number, Parent:FlxObject = null) {
			// Basic init
			super(Projectiles, X, Y, Parent);
		}

		// Initialize Graphics		
		override public function initGraphics():void {
			// Animation and Graphic
			loadGraphic(ImgBigSquid, true, false, 202, 350);
			addAnimation("default", [0, 1, 2, 3, 4, 5, 6], 5, true);
			// Randomize which frame we start with
			_curFrame = Math.floor(Math.random() * 7);
			play("default");
			// Collision
			width = 96;
			height = 115;
			offset.x = 50;
			offset.y = 155;
		}
	}
}
