package bosses.duck {
	import base.Proj;
	import base.ProjSpawner;

	import org.flixel.FlxObject;
	import org.flixel.FlxU;

	/**
	 * @author Yori Kvitchko
	 */
	public class DuckEyeSpawner extends ProjSpawner {
		private static const BULLET_SPEED:Number = 350;
		
		public var leftFacing:Boolean;
		
		public function DuckEyeSpawner(X:Number, Y:Number, Interval:Number, LeftFacing:Boolean, Parent:FlxObject = null) {
			super(X, Y, Interval, DuckProj, 100, Parent);
			leftFacing = LeftFacing;
		}

		override public function sendProjectile(X:Number, Y:Number, p:Proj, locationIndex:int):void {
			var tmpAngle:Number;
			
			// Send it
			super.sendProjectile(X, Y, p, locationIndex);
			
			// Angle up or down
			if(leftFacing)
				tmpAngle = 90;
			else
				tmpAngle = -90;
			// Set Parameters
			Proj(p).velocity = FlxU.rotatePoint(BULLET_SPEED, 0, 0, 0, tmpAngle + locationIndex * 36);
			// Set Angle
			//Proj(p).angle = tmpAngle;
		}
	}
}
