package bosses.eye
{
	import bosses.BossComp;
	
	import org.flixel.FlxGroup;
	import org.flixel.FlxObject;

	public class EyeBossDummyComp extends BossComp
	{
		[Embed(source='../../../data/iris.png')]
		private const ImgIris:Class;
		
		private var _irisOpenning:Boolean;
		
		public function EyeBossDummyComp(Projectiles:FlxGroup=null, X:Number=0, Y:Number=0, Parent:FlxObject=null)
		{
			super(Projectiles, X, Y, Parent);
			irisOpenning = false;
			solid = false;
			//blend = "overlay";
			blend = "normal";
		}
		
		override public function initGraphics():void
		{
			loadGraphic(ImgIris);
		}
		
		override public function update():void
		{
			super.update();	
			if(!_irisOpenning)
			{
				var shipX:Number = SpaceView.ship.x + SpaceView.ship.origin.x;
				var shipY:Number = SpaceView.ship.y + SpaceView.ship.origin.y;
				var dX:Number = shipX-(x+width/2);
				var dY:Number = shipY-(y+height/2);
				var distance:Number = Math.sqrt(dX*dX+dY*dY);
							
				if(distance <= EyeBoss.EYE_RADIUS)
				{
					SpaceView.ship.hurt(1);
				}
			}
		}
		
		public function get irisOpenning():Boolean {
			return _irisOpenning;
		}
		
		public function set irisOpenning(openning:Boolean):void
		{
			_irisOpenning = openning;
		}
	}
}