package bosses.gates
{
	import bosses.BossComp;
	import org.flixel.FlxObject;
	import org.flixel.FlxGroup;

	public class GatesBossBlockerComp extends BossComp
	{
		private var _type:int;
	
		[Embed(source="../../../data/gates_boss/door_l.png")]
		private var ImgGatesDoorL:Class;
		
		[Embed(source="../../../data/gates_boss/door_r.png")]
		private var ImgGatesDoorR:Class;
		
		[Embed(source="../../../data/gates_boss/door_t.png")]
		private var ImgGatesDoorT:Class;
		
		[Embed(source="../../../data/gates_boss/door_b.png")]
		private var ImgGatesDoorB:Class;
		
		public function GatesBossBlockerComp(Projectiles:FlxGroup=null, X:Number=0, Y:Number=0, Parent:FlxObject=null, type:int=0)
		{
			_type = type;
			super(Projectiles, X, Y, Parent);
			_invincible = true;
		}
		
		override public function initGraphics():void
		{
			if(_type == 0)
			{
				loadGraphic(ImgGatesDoorT, true);
			}
			else if(_type == 1)
			{
				loadGraphic(ImgGatesDoorB, true);
			} 
			else if(_type == 2)
			{
				loadGraphic(ImgGatesDoorL, true);
			}
			else if(_type == 3)
			{
				loadGraphic(ImgGatesDoorR, true);
			}
			addAnimation("passive", [0]);
			addAnimation("active", [1]);
			setPassive();
			visible = true;
		}

		public function setPassive():void {
			play("passive");
		}
		
		public function setActive():void {
			play("active");
		}
	}
}