package bosses.gates
{
	import base.Proj;
	
	import org.flixel.FlxG;

	public class GatesLaserProjH extends Proj
	{		
		private static const EXPLOSION_OFFSET_X:Number = 80;
		private static const EXPLOSION_HEIGHT:Number = 200;
		private static const EXPLOSION_WIDTH:Number = 50;
		
		[Embed(source="../../../data/gates_boss/laser_h.png")]
		private var ImgGatesLaserH:Class;
		
		private const LASER_TIMER_INTERVAL:Number = 1;
		private const LASER_FREEZE_INTERVAL:Number = 2;
		
		private var _laserFreezeTimer:Number;
		private var _laserTimer:Number;
		public var _type:int;
		
		public function GatesLaserProjH()
		{
			_laserFreezeTimer = LASER_FREEZE_INTERVAL;
			_laserTimer = LASER_TIMER_INTERVAL;
			super();
		}
		
		override public function initGraphics():void
		{
			loadGraphic(ImgGatesLaserH);
		}
		
		override public function update():void
		{
			super.update();
			y = GatesBoss(SpaceView.enemy).y + 200 - height/2;
			if(_type == 0)
			{
				x = GatesBoss(SpaceView.enemy).x + 225;	
			}
			else if(_type == 1)
			{
				x = GatesBoss(SpaceView.enemy).x + 175 - width;	
			}
			
			if(_laserFreezeTimer >= 0)
			{
				_laserFreezeTimer -= FlxG.elapsed;
				solid = false;
			}
			else
			{
				if(scale.y < 1)
				{
					scale.y += 2*FlxG.elapsed;
					solid = false;
				}
				else
				{
					solid = true;
					_laserTimer -= FlxG.elapsed;
					GatesBoss(SpaceView.enemy)._laserShooting = false;
					if(_laserTimer < 0) 
					{
						kill();
						_laserTimer = LASER_TIMER_INTERVAL;
					}	
				}
			}
			if(SpaceView.explosions.exploding)
			{
				if(GatesBoss(SpaceView.enemy)._blockerExploding2 ||
					GatesBoss(SpaceView.enemy)._blockerExploding4)
					updateExplosion();
			}
			else
			{
				GatesBoss(SpaceView.enemy)._blockerExploding2 = false;
				GatesBoss(SpaceView.enemy)._blockerExploding4 = false;
			}
			
		}
		
		override public function reset(X:Number, Y:Number):void
		{
			super.reset(X,Y);
			scale.y = 0.1;
		}
		
		override public function reflect():void 
		{
			/* if(solid)
			{ */
				if(_type == 0)
				{
					GatesBoss(SpaceView.enemy)._blockerAlive2 = false;
					GatesBoss(SpaceView.enemy)._blockerExploding2 = true;
					SpaceView.explosions.explode(x+EXPLOSION_OFFSET_X, y+height/2-EXPLOSION_HEIGHT/2, EXPLOSION_WIDTH, EXPLOSION_HEIGHT, 2);
				}
				else if(_type == 1)
				{
					GatesBoss(SpaceView.enemy)._blockerAlive4 = false;
					GatesBoss(SpaceView.enemy)._blockerExploding4 = true;
					SpaceView.explosions.explode(x+width-EXPLOSION_OFFSET_X, y+height/2-EXPLOSION_HEIGHT/2, EXPLOSION_WIDTH, EXPLOSION_HEIGHT, 2);
				}
				kill();
				_laserTimer = LASER_TIMER_INTERVAL;
			//}
		}
		
		public function updateExplosion():void
		{
			if(_type == 0 && GatesBoss(SpaceView.enemy)._blockerExploding2)
			{
				SpaceView.explosions.reset(x+EXPLOSION_OFFSET_X, y+height/2-EXPLOSION_HEIGHT/2);
			}
			else if(_type == 1 && GatesBoss(SpaceView.enemy)._blockerExploding4)
			{
				SpaceView.explosions.reset(x+width-EXPLOSION_OFFSET_X, y+height/2-EXPLOSION_HEIGHT/2);
			}
		}  
	}
}