package bosses.gates
{
	import base.Proj;
	
	import org.flixel.FlxG;

	public class GatesLaserProjV extends Proj
	{
		private static const EXPLOSION_OFFSET_Y:Number = 80;
		private static const EXPLOSION_WIDTH:Number = 200;
		private static const EXPLOSION_HEIGHT:Number = 50;
		
		
		[Embed(source="../../../data/gates_boss/laser_v.png")]
		private var ImgGatesLaserV:Class;
		
		private const LASER_TIMER_INTERVAL:Number = 1;
		private const LASER_FREEZE_INTERVAL:Number = 2;
		
		private var _laserFreezeTimer:Number;
		private var _laserTimer:Number;
		public var _type:int;
		
		public function GatesLaserProjV()
		{
			_laserFreezeTimer = LASER_FREEZE_INTERVAL;
			_laserTimer = LASER_TIMER_INTERVAL;
			super();
		}
		
		override public function initGraphics():void
		{
			loadGraphic(ImgGatesLaserV);
		}
		
		override public function update():void
		{
			super.update();
			
			x = GatesBoss(SpaceView.enemy).x + 200 - width/2;
			if(_type == 0)
			{
				y = GatesBoss(SpaceView.enemy).y + 225;	
			}
			else if(_type == 1)
			{
				y = GatesBoss(SpaceView.enemy).y + 175 - height;
			}
			
			if(_laserFreezeTimer >= 0)
			{
				_laserFreezeTimer -= FlxG.elapsed;
				solid = false;
			}
			else
			{
				if(scale.x < 1)
				{
					scale.x += 2*FlxG.elapsed;
					solid = false;
				}
				else
				{
					solid = true;
					_laserTimer -= FlxG.elapsed;
					GatesBoss(SpaceView.enemy)._laserShooting = false;
					if(_laserTimer < 0) 
					{
						kill();
						_laserTimer = LASER_TIMER_INTERVAL;
					}	
				}
			}
			if(SpaceView.explosions.exploding)
			{
				if(GatesBoss(SpaceView.enemy)._blockerExploding1 ||
					GatesBoss(SpaceView.enemy)._blockerExploding3)
					updateExplosion();
			}
			else
			{
				GatesBoss(SpaceView.enemy)._blockerExploding1 = false;
				GatesBoss(SpaceView.enemy)._blockerExploding3 = false;
			}
			
		}
		
		override public function reset(X:Number, Y:Number):void
		{
			super.reset(X,Y);
			scale.x = 0.1;
		}
		
		override public function reflect():void 
		{
			/* if(solid)
			{ */
				if(_type == 0)
				{
					GatesBoss(SpaceView.enemy)._blockerAlive1 = false;
					GatesBoss(SpaceView.enemy)._blockerExploding1 = true;
					SpaceView.explosions.explode(x+width/2-EXPLOSION_WIDTH/2, y+EXPLOSION_OFFSET_Y, EXPLOSION_WIDTH, EXPLOSION_HEIGHT, 2);
				}
				else if(_type == 1)
				{
					GatesBoss(SpaceView.enemy)._blockerAlive3 = false;
					GatesBoss(SpaceView.enemy)._blockerExploding3 = true;
					SpaceView.explosions.explode(x+width/2-EXPLOSION_WIDTH/2, y+height-EXPLOSION_OFFSET_Y, EXPLOSION_WIDTH, EXPLOSION_HEIGHT, 2);
				}
				kill();
				_laserTimer = LASER_TIMER_INTERVAL;
			//}
		}
		
		public function updateExplosion():void
		{
			if(_type == 0 && GatesBoss(SpaceView.enemy)._blockerExploding1)
			{
				SpaceView.explosions.reset(x+width/2-EXPLOSION_WIDTH/2, y+EXPLOSION_OFFSET_Y);
			}
			else if(_type == 1 && GatesBoss(SpaceView.enemy)._blockerExploding3)
			{
				SpaceView.explosions.reset(x+width/2-EXPLOSION_WIDTH/2, y+height-EXPLOSION_OFFSET_Y);
			}
		}  
	}
}