package bosses.gates
{
	import base.Proj;
	import base.ProjSpawner;
	
	import org.flixel.FlxU;
	import org.flixel.FlxObject;

	public class GatesSpawner extends ProjSpawner
	{
		private static const BULLET_SPEED:Number = 200;
		private var _numProj:int;
		private var _startAngle:Number;
		public function GatesSpawner(num:int, angle:Number, Parent:FlxObject = null)
		{
			_numProj = num;
			_startAngle = angle;
			super(0, 0, 0, GatesProj, 24, Parent);
		}
		
		override public function sendProjectile(X:Number, Y:Number, p:Proj, locationIndex:int):void
		{
			var tmpAngle:Number;
			
			// Send it
			super.sendProjectile(X, Y, p, locationIndex);
			
			// Angle
			tmpAngle = _startAngle+(45/_numProj)*locationIndex;
			// Set Parameter
			Proj(p).velocity = FlxU.rotatePoint(BULLET_SPEED, 0, 0, 0, tmpAngle);
			// Set Angle
			Proj(p).angle = tmpAngle;
			
		}
		
	}
}