package bosses.gates
{
	import bosses.BossComp;
	
	import org.flixel.FlxG;
	import org.flixel.FlxGroup;
	import org.flixel.FlxObject;

	public class GatesWeaponComp extends BossComp
	{
		// Constants
		private static const WEAPON_X_MOVEMENT:Number = 200;
		private static const WEAPON_Y_MOVEMENT:Number = 200;
		
		// Variables
		private var _triggered:Boolean;
		private var _type:int;
		
		public function GatesWeaponComp(Projectiles:FlxGroup=null, X:Number=0, Y:Number=0, Parent:FlxObject=null)
		{
			super(Projectiles, X, Y, Parent);
			_invincible = true;
			visible = false;
			_triggered = false;
			_type = 0;
		}
		
		override public function initGraphics(): void
		{
			createGraphic(30, 200, 0xff00ff00);
		}
		
		public function trigger(X:Number, Y:Number, type:int):void
		{
			visible = true;
			_triggered = true;
			x = X;
			y = Y;
			// Vertical
			if(type == 0)
			{
				createGraphic(30, 200, 0xff00ff00);
			}
			// Horizontal
			if(type == 1)
			{
				createGraphic(200, 30, 0xff00ff00);
			}
			
		}
		
		override public function update():void
		{
			if(_triggered)
			{
				// Vertical
				if(_type == 0)
				{
					y += WEAPON_Y_MOVEMENT*FlxG.elapsed;
				}
				// Horizontal
				if(_type == 1)
				{
					x += WEAPON_X_MOVEMENT*FlxG.elapsed;
				}
			}
			super.update();
		}
	}
}