package bosses.jellyfish {
	import base.Proj;
	
	import flash.geom.Point;
	
	import org.flixel.FlxG;

	public class JellyFishBabyProj extends Proj {

		[Embed(source="../../../data/boss_jellyfish_baby.png")]
		private var ImgJellyFishBullet:Class;

		private static const BIG_INTERVAL:Number = 0.5;
		private static const BIG_BOOST:Number = 300;
		private static const SMALL_INTERVAL:Number = 1;

		private static const SMALL_BOOST:Number = 200;
		private var _interval:Interval;		
		private static var _tmp:Point;

		public function JellyFishBabyProj() {
			super();
			
			_interval = new Interval([SMALL_INTERVAL, SMALL_INTERVAL, SMALL_INTERVAL, SMALL_INTERVAL]);
			_tmp = new Point(0, 0);
			
			drag.x = 200;
			drag.y = 200;
			solid=true;
						
			reflectedDamage = 90;
		}

		override public function initGraphics():void {
			loadGraphic(ImgJellyFishBullet, true);
			addAnimation("default", [0, 1, 2, 3, 4, 5, 6, 7], 3);
			addAnimation("reflected", [8, 9, 10, 11, 12, 13, 14, 15], 3);
			frame = Math.floor(Math.random()*8);
			play("default");
		}

		override public function update():void {
			super.update();
			
			// Progress the interval state machine, basically move the clock forward
			_interval.elapse(FlxG.elapsed);
			
			// This means the current interval just passed
			if(_interval.justTicked) {
				// Set _tmp to the difference between my location and ship's location
				if(reflected)
				{
					//direct the baby jellyfish towards its mother 
					_tmp.x = SpaceView.enemy.x - this.x;
					_tmp.y = SpaceView.enemy.y - this.y;
				}
				else
				{
					//direct baby jellyfish towards player ship
					_tmp.x = SpaceView.ship.x - this.x;
					_tmp.y = SpaceView.ship.y - this.y;
				}
				// If the current interval is the first interval (which is the BIG_INTERVAL) give me a BIG_BOOST
				// Otherwise just use a SMALL_BOOST
				// This is done by normalizing the difference vector stored in _tmp to the BOOST value we want
				if(_interval.currentInterval == 0)
					_tmp.normalize(BIG_BOOST);
				else
					_tmp.normalize(SMALL_BOOST);
				
				// Add the boost to the current velocity
				velocity.x += _tmp.x+Math.random()*100;
				velocity.y += _tmp.y+Math.random()*100;
			}
		}
		
		override public function reflect():void {
			reflected = true;
			play("reflected");
			frame = Math.floor(Math.random()*8 + 8);
		}

		override public function reset(X:Number, Y:Number):void {
			super.reset(X, Y);
			play("default");
			frame = Math.floor(Math.random()*8);
		}	
	}
}