package bosses.jellyfish {
	import bosses.BossComp;

	import org.flixel.FlxGroup;
	import org.flixel.FlxObject;
	import org.flixel.FlxSprite;

	/**
	 * @author Yori Kvitchko
	 */
	public class JellyFishBossComp extends BossComp {

		[Embed(source='../../../data/boss_jellyfish_1.png')]
		private const ImgJellyFish1:Class;

		[Embed(source='../../../data/boss_jellyfish_2.png')]
		private const ImgJellyFish2:Class;

		[Embed(source='../../../data/boss_jellyfish_3.png')]
		private const ImgJellyFish3:Class;

		private var _img2:FlxSprite;
		private var _img3:FlxSprite;

		public function JellyFishBossComp(Projectiles:FlxGroup, X:Number, Y:Number, Parent:FlxObject = null) {
			// Basic init
			super(Projectiles, X, Y, Parent);
		}

		// Initialize Graphics		
		override public function initGraphics():void {
			// Animation and Graphic
			loadGraphic(ImgJellyFish1);
			_img2 = new FlxSprite(_parent.x, _parent.y, ImgJellyFish2);
			_img3 = new FlxSprite(_parent.x, _parent.y, ImgJellyFish3);
		}
		override public function update():void {
			super.update();
			
			_img3.x = _img3.x + (_img2.x - _img3.x) / 2;
			_img3.y = _img3.y + (_img2.y - _img3.y) / 2;
			
			_img2.x = _img2.x + (x - _img2.x) / 2;
			_img2.y = _img2.y + (y - _img2.y) / 2;
		}

		override public function render():void {
			super.render();
			_img2.render();
			_img3.render();
		}
	}
}
