package bosses.wave {
	import bosses.BossComp;

	import org.flixel.FlxG;
	import org.flixel.FlxGroup;
	import org.flixel.FlxObject;

	public class WaveBossComp extends BossComp {

		[Embed(source="../../../data/boss_wave.png")]
		private var ImgWave:Class;

		private var _cryTimer:Number;

		public function WaveBossComp(Projectiles:FlxGroup = null, X:Number = 0, Y:Number = 0, Parent:FlxObject = null) {
			super(Projectiles, X, Y, Parent);
			_cryTimer = 0;
		}

		override public function initGraphics():void {
			loadGraphic(ImgWave, true);
			addAnimation("default", [0]);
			addAnimation("cry", [1]);
			play("default");
		}

		
		override public function update():void {
			if(_cryTimer > 0) {
				_cryTimer -= FlxG.elapsed;
			} else {
				if(_curAnim.name != "default")
					play("default");
			}
			super.update();
		}

		override public function hurt(Damage:Number):void {
			super.hurt(Damage);
			// Cry
			_cryTimer = 0.1;
			if(_curAnim.name != "cry")
				play("cry");
		}
	}
}