package bosses.wave
{
	import base.Proj;
	import base.ProjSpawner;
	
	import org.flixel.FlxObject;
	import org.flixel.FlxU;

	public class WaveExplodeSpawner extends ProjSpawner
	{
		private static const BULLET_SPEED:Number = 200;
		private static const HALF_PI:Number = Math.PI/2;
		
		public function WaveExplodeSpawner(Parent:FlxObject=null)
		{
			super(0, 0, 0, WaveProj, 24, Parent);
		}
		
		override public function sendProjectile(X:Number, Y:Number, p:Proj, locationIndex:int):void
		{
			var tmpAngle:Number;
			
			// Send it
			super.sendProjectile(X, Y, p, locationIndex);
			
			// Angle
			tmpAngle = 30*locationIndex;
			// Set Parameters
			Proj(p).velocity = FlxU.rotatePoint(BULLET_SPEED, 0, 0, 0, tmpAngle);
			// Set Angle
			Proj(p).angle = tmpAngle;
			
			/* WaveProj(p)._growing = false;
			WaveProj(p).reloadGraphics(); */
		}
		
	}
}