package bosses.wave
{
	import base.Proj;
	import org.flixel.FlxG;

	public class WaveGrowProj extends Proj
	{
		[Embed(source="../../../data/boss_wave_big_bullet.png")]
		private var ImgWaveBigBullet:Class;
		
		public function WaveGrowProj()
		{
			super();
		}
		
		override public function initGraphics():void 
		{
			loadGraphic(ImgWaveBigBullet);
		}
		
		override public function update():void
		{
			super.update();
			
			if(scale.x < 2)
			{
				scale.x += 0.7*FlxG.elapsed;
				scale.y += 0.7*FlxG.elapsed; 
				updateCollision(); 
			}
			else
			{
				kill();
				// need to adjust the center point of the explosion
				WaveBoss(SpaceView.enemy).triggerExplosion(x+width/2,y+height/2);
				
			}
		}
		
		public function updateCollision():void
		{
			width = frameWidth * scale.x * 0.65;
			height = frameHeight * scale.y * 0.65;
			offset.x = (frameWidth - width * 0.975) / 2;
			offset.y = (frameHeight - height * 0.975) / 2;
		}
		
		override public function reset(X:Number, Y:Number):void
		{
			super.reset(X,Y);
			scale.x = 0.3;
			scale.y = 0.3;	
		}
		
		 override public function reflect():void 
		{
			if(SpaceView.ship.health + 2 > 4)
				SpaceView.ship.health = 4;
			else
				SpaceView.ship.health += 2;
			kill();
		}  
		
	}
}