package bosses.whip {
	import base.Proj;

	/**
	 * @author Yori Kvitchko
	 */
	public class WhipProj extends Proj {
		[Embed(source="../../../data/boss_whip_bullet.png")] 
		private var ImgWhipBullet:Class;
		
		// 0 for not exploding, anything else for index of exploder to use
		private var _exploding:int;
		
		public function WhipProj() {
			super();
			exploding = 0;
			reflectedDamage = 6;
		}

		override public function initGraphics():void {
			loadRotatedGraphic(ImgWhipBullet, 4);
		}

		override public function reset(X:Number, Y:Number):void {
			if(_exploding > 0) {
				WhipBoss(SpaceView.enemy).triggerExplosion(x, y, exploding - 1);
			}
			exploding = 0;
			
			super.reset(X, Y);
		}

		override public function kill():void {
			super.kill();
			exploding = 0;
		}

		public function get exploding():int {
			return _exploding;
		}

		public function set exploding(value:int):void {
			_exploding = value;
			
			if(value) {
				color = 0xffff00ff;
			} else {
				color = 0xff00ff00;
			}
		}

		override public function reflect():void {
			super.reflect();
			exploding = 0;
			color = 0xffffffff;
		}
	}
}
