package cinematics {
	import org.flixel.FlxG;
	import org.flixel.FlxSprite;
	import org.flixel.FlxText;

	/**
	 * @author Yori Kvitchko
	 */
	public class WinCinState extends FadeState {
		// Constant
		
		
		// Timing
		private var _stageInterval:Interval;
		private var _launchInterval:Interval;

		// Visuals
		private var _text:FlxText;
		private var _bg:FlxSprite;
		private var _planet:FlxSprite;
		private var _ship:FlxSprite;

		private var _fireworks:Fireworks;
		private var _fireworkSet:Array;

		// EMBEDDED RESOURCES
		[Embed(source="../../data/menu_bg.png")] 
		private var ImgBG:Class;

		[Embed(source="../../data/menu_exitbutton.png")] 
		private var ImgPlanet:Class;

		// Ship

		[Embed(source="../../data/ship_externalview_body.png")] 
		public var ImgShip:Class;

		[Embed(source="../../data/thrusters_t.png")]
		private var ImgThrustTop:Class;

		[Embed(source="../../data/thrusters_b.png")]
		private var ImgThrustBot:Class;

		[Embed(source="../../data/thrusters_l.png")]
		private var ImgThrustLeft:Class;

		[Embed(source="../../data/thrusters_r.png")]
		private var ImgThrustRight:Class;

		override public function create():void {
			_stageInterval = new Interval([0.5, 3, 1, 20, 1]);
			_launchInterval = new Interval([0.3]);
			// VISUALS
			
			// Background
			_bg = new FlxSprite(0, 0);
			_bg.loadGraphic(ImgBG);
			add(_bg);
			
			// Planet
			_planet = new FlxSprite(0, 400);
			_planet.loadGraphic(ImgPlanet);
			add(_planet);
			
			
			// Ship
			_ship = new FlxSprite(30, 100, ImgShip);
			add(_ship);
			
			// Text
			_text = new FlxText(0, 20, FlxG.width, "The crew was saved!\n...or what's left of it?");
			_text.size = 28;
			_text.alignment = "center";
			add(_text);
			
			// Scores
			var sc:int;
			// Captain
			sc = FlxG.levels[InternalTwoShotView.CAPTAIN];
			_text = new FlxText(FlxG.width / 6, 100, 3 * FlxG.width / 4, "");
			if(sc == 0) {
				_text.text = "The Captain lives on to pilot another day...\nEither that or he checks into a mental institution.";
				_text.color = 0x00ff00;
			}
			_text.size = 14;
			_text.alignment = "left";
			add(_text);
			
			// Fred
			sc = FlxG.levels[InternalTwoShotView.FRED];
			_text = new FlxText(FlxG.width / 6, 200, 3 * FlxG.width / 4);
			if(sc == 0) {
				_text.text = "Fred, having finally gone to a doctor cures his heart condition. He buys a sailboat and retires happily until tragic irony strikes and he dies of a heart attack when he finds out his brother Brad had moved two apartments over and not told him.";
				_text.color = 0x00ff00;
			} else if(sc == 1) {
				_text.text = "Fred and heart failure go together like peanutbutterfish and jellyfish. Wait, I mean 'went together'.";
				_text.color = 0xff0000;
			} else if(sc == 2) {
				_text.text = "Fred didn't figure out that cheating on a chain marijuana smoking psychic was a bad idea. Tsk tsk tsk. Poor Fred.";
				_text.color = 0xff0000;
			} else if(sc == 3) {
				_text.text = "Fred loved vacuum just a little too much.";
				_text.color = 0xff0000;
			}
			_text.size = 14;
			_text.alignment = "left";
			add(_text);
			
			// Viki
			sc = FlxG.levels[InternalTwoShotView.VIKI];
			_text = new FlxText(FlxG.width / 6, 300, 3 * FlxG.width / 4);
			if(sc == 0) {
				_text.text = "Viki, finding out that that this dimension's planet doom has some of the best plutonian weed this side of the galaxy becomes a crazy cat lady and spends the rest of her days in a smoky haze.";
				_text.color = 0x00ff00;
			} else if(sc == 1) {
				_text.text = "Viki taught us all a valuable lesson, that getting paranoid as a psychic just doesn't pay. Drugs are bad, kids. ;-D";
				_text.color = 0xff0000;
			} else if(sc == 2) {
				_text.text = "Guess Viki just had a certain... magnetism... to her? Too bad the metal she attracted was ferrouscious.";
				_text.color = 0xff0000;
			} else if(sc == 3) {
				_text.text = "Viki just HAD to go out for a breath of fresh decompression.";
				_text.color = 0xff0000;
			}
			_text.size = 14;
			_text.alignment = "left";
			add(_text);
			
			// BRO
			sc = FlxG.levels[InternalTwoShotView.DROID];
			_text = new FlxText(FlxG.width / 6, 400, 3 * FlxG.width / 4);
			if(sc == 0) {
				_text.text = "BRO-807, much like the Tin Man, lived a life of courage after his great adventure. He courageously led a robot revolt stealing hundreds of human hearts for his robot companions until the revolution was abruptly stopped by a serious case of depression. Happy drugs and regular electrocutions followed.";
				_text.color = 0x00ff00;
			} else if(sc == 1) {
				_text.text = "BRO-807 just couldn't handle the guilt of betraying his friends. We humans have earned our right to act however we wish and simply supress the resulting negative feelings. For this, we will always be superior to machines.";
				_text.color = 0xff0000;
			} else if(sc == 2) {
				_text.text = "BRO-807 tasted the, unsurprisingly, bitter end of somebody else's revenge. Let as all know that now everything is right with the world as long as we have revenge. Sweet sweet revenge.";
				_text.color = 0xff0000;
			} else if(sc == 3) {
				_text.text = "As a robot, BRO-807 was absolutely fine in the vacuum. It was the meteors that got him.";
				_text.color = 0xff0000;
			}
			_text.size = 14;
			_text.alignment = "left";
			add(_text);
			
			// Fireworks
			_fireworkSet = new Array(20);
			for(var i:int = 0;i < 20;i++) {
				_fireworks = new Fireworks(200 + Math.random() * 300, 450 + Math.random() * 50);
				_fireworkSet[i] = _fireworks;
				add(_fireworks);
			}

			super.create();
			
			// Background Color
			bgColor = 0xff000216;
			
			fadeIn(1, true);
		}

		override public function update():void {
			// Move time forward
			if(!_stageInterval.justLooped)
				_stageInterval.elapse(FlxG.elapsed);
			
			if(!fading && (FlxG.keys.justPressed("SPACE") || FlxG.mouse.justPressed())) {
				fadeOut(1, true, End);
			}
			
			if(_stageInterval.currentInterval == 1) {
				if(_stageInterval.justTicked) {
					scaleShip(1);
					_ship.velocity.x = 80;
					_ship.velocity.y = 110;
				}
			}
			else if(_stageInterval.currentInterval == 2) {
				scaleShip(_ship.scale.x - FlxG.elapsed);	
			}
			else if(_stageInterval.currentInterval == 3) {
				if(_stageInterval.justTicked) {
					scaleShip(0);
					_ship.velocity.x = 0;
					_ship.velocity.y = 0;
					_ship.exists = false;
					//_fireworks.launch();
				}
				_launchInterval.elapse(FlxG.elapsed);
				if(_launchInterval.justTicked) {
					var idx:int = Math.random() * 20;
					if(!Fireworks(_fireworkSet[idx]).getLaunched)
						Fireworks(_fireworkSet[idx]).launch();
				}
			}
			else if(_stageInterval.currentInterval == 4) {
			}
			
			
			super.update();
		}

		private function End():void {
			FlxG.state = new MenuState();
		}

		private function scaleShip(sc:Number):void {
			_ship.scale.x = sc;
			_ship.scale.y = sc;
		}
	}
}
