package player {
	import base.Proj;
	import org.flixel.FlxG;
	import org.flixel.FlxU;

	/**
	 * @author Yori Kvitchko
	 */
	public class PlayerProj extends Proj {
		/*
		 * Bullet speed
		 */
		public static const BULLET_SPEED:Number = 1200;

		[Embed(source="../../data/ship_bullet.png")] 
		private var ImgBullet:Class;

		public function PlayerProj() {
			super();
		}

		/*
		 * Initialize Graphics
		 */
		override public function initGraphics():void {
			loadRotatedGraphic(ImgBullet, 4);
		}

		/*
		 * Resets and sends the bullet on its way
		 */
		override public function send(X:Number, Y:Number, locationIndex:int):void {
			// Handles resetting for us
			super.send(X, Y, locationIndex);
			
			// Set angle and velocity
			angle = Math.atan2(FlxG.mouse.y - Y - origin.y, FlxG.mouse.x - X - origin.x) * 180 / Math.PI;
			velocity = FlxU.rotatePoint(BULLET_SPEED, 0, 0, 0, angle);
		}
	}
}
