package player {
	import bosses.Boss;

	import org.flixel.FlxObject;
	import org.flixel.FlxSprite;

	import flash.geom.Rectangle;

	/**
	 * @author Yori Kvitchko
	 */
	public class PlayerShipHealth extends FlxSprite {
		private var healthBar:FlxSprite;
		private var healthRect:Rectangle;

		/*
		 * Logo Health Image
		 */
		[Embed(source="../../data/ship_health_logo.png")] 
		private var ImgLogo:Class;

		/*
		 * A component of a larger boss, can be either independant or dependant on a parent
		 */
		public function PlayerShipHealth(X:Number, Y:Number) {
			super(X, Y, ImgLogo);
			moves = false;
			solid = false;
			
			healthBar = new FlxSprite();
			healthBar.createGraphic(108, 16, 0xff00ff00, true);
			healthBar.x = x + 4;
			healthBar.y = y + 4;
			
			scrollFactor.x = healthBar.scrollFactor.x = 0;
			scrollFactor.y = healthBar.scrollFactor.y = 0;
			
			healthRect = new Rectangle(0, 0, 0, 20);
		}

		override public function update():void {
			super.update();
			
			healthBar.x = x + 4;
			healthBar.y = y + 4;
			healthRect.width = Math.floor((1 - ((SpaceView.ship.health-1) / 3)) * 108);
			healthRect.x = 108 - healthRect.width;
		}

		override public function render():void {
			healthBar.pixels.fillRect(healthRect, 0xffff0000);
			healthBar.frame = 0;
			healthBar.render();
			super.render();
		}
	}
}
